var objLoggViewLog =
{
	objMediator: Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator),
	objMozillaPrefs: Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch),
	objPrefs: Components.classes["@mozilla.org/preferences-service;1"].
         		getService(Components.interfaces.nsIPrefService).getBranch('extensions.Shingles.'),

	Init: function()
	{
		document.getElementById('Logg-view-tree').view = objLoggTreeView;

		return true;
	},

	Open: function(nIndex)
	{
		var sURL = this.GetRowCell(nIndex, 'view-tree-url');
		var objBrowser = this.objMediator.getMostRecentWindow('navigator:browser').getBrowser();

		objBrowser.loadURI(sURL, null, null);

		return true;
	},

	OpenWindow: function(nIndex)
	{
		var sURL = this.GetRowCell(nIndex, 'view-tree-url');

		window.open(sURL);

		return true;
	},

	OpenTab: function(nIndex)
	{
		var bTabDefault = (this.objMozillaPrefs.getPrefType('browser.tabs.loadInBackground') == this.objMozillaPrefs.PREF_BOOL) ? this.objMozillaPrefs.getBoolPref('browser.tabs.loadInBackground') : true;
		var sURL = this.GetRowCell(nIndex, 'view-tree-url');
		var objBrowser = this.objMediator.getMostRecentWindow('navigator:browser').getBrowser();

		var objTab = objBrowser.addTab(sURL, null, null);
		if (!bTabDefault) objBrowser.selectedTab = objTab;

		return true;
	},

	Delete: function(nIndex) {
		var rowId = this.GetRowCell(objLoggTreeView.selection.currentIndex, 'view-tree-rowid');
		var objLogg = this.GetLogg();

		objLoggTreeView.treeBox.rowCountChanged(nIndex, -1);

		objLogg.BeginTransaction();
		objLogg.objDeleteLog.bindInt32Parameter(0, rowId);
		objLogg.objDeleteLog.execute();

		var nRowCount = this.GetRowCount();
		if (!nRowCount) return true;
		if (nRowCount == nIndex)
		{
			objLoggTreeView.selection.select(nIndex - 1);
			return true;
		}

		objLoggTreeView.selection.select(nIndex);

		return true;
	},

	DeleteAll: function()
	{
		return false;
		/*
		var objLogg = this.GetLogg();
		var nRowCount = this.GetRowCount();

		objLogg.UpdateSidebarRowCount(0, nRowCount * -1);

		objLogg.BeginTransaction();
		objLogg.objTruncatePages.execute();

		objLogg.BeginTransaction();
		objLogg.objTruncateMarks.execute();

		var objWindows = this.objMediator.getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();

			try
			{
				if (!objWindow.objLogg) continue;

				var ndWindowBody, aWindows = objLogg.GetOpenWindows(objWindow);
				for (var nWindow = 0; aWindows[nWindow]; ++nWindow)
				{
					objWindow.objLogg.Reset(aWindows[nWindow].document.body);
				}
			}
			catch (sError)
			{
				continue;
			}
		}

		return true;
		*/
	},

	Hide: function()
	{
		var objWindow = this.objMediator.getMostRecentWindow('navigator:browser');
		if (!objWindow.objLogg)
		{
			return true;
		}

		//objWindow.toggleSidebar('dogears-sidebar-bc');
		return true;
	},

	Click: function(e)
	{
		return true;
		/*
		if (e.button > 1) return true;

		var objRow = {}, objColumn = {}, ndSource = {};
		objLoggTreeView.treeBox.getCellAt(e.clientX, e.clientY, objRow, objColumn, ndSource);
		if (!ndSource.value || (ndSource.value == 'twisty')) return true;

		if (((e.button == 0) && e.ctrlKey) || (e.button == 1)) return objLoggViewLog.OpenTab(objRow.value);
		if ((e.button == 0) && e.shiftKey) return objLoggViewLog.OpenWindow(objRow.value);

		return objLoggViewLog.Open(objRow.value);
		*/
	},

	Cancel: function(e)
	{
		e.preventDefault();
		e.stopPropagation();

		return false;
	},

	Keypress: function(e)
	{
		if ((e.keyCode != 13) && (e.keyCode != 46)) return true;

		var nIndex = objLoggTreeView.selection.currentIndex;
		if (nIndex < 0) return true;

		if (e.keyCode == 46) return objLoggViewLog.Delete(nIndex);
		if (e.ctrlKey) return objLoggViewLog.OpenTab(nIndex);
		if (e.shiftKey) return objLoggViewLog.OpenWindow(nIndex);

		return objLoggViewLog.Open(nIndex);
	},

	GetLogg: function()
	{
		var objWindow = this.objMediator.getMostRecentWindow('navigator:browser');
		if (objWindow.objLogg)
		{
			return objWindow.objLogg;
		}

		return false;
	},

	CopyToBufer: function()	{
		var i, len;

		var objLogg = this.GetLogg();

		var objData = [];
		len = this.GetRowCount();
		for (i=0; i < len; i++) {
			objData.push(this.GetRow(i));
		}

		var arr = [];
		len = objData.length;
		var t, j, props;
		for (i=0; i < len; i++) {
			t = [];
/*
			for (j in objData[i]) {
				t.push(objData[i][j]);
			}
*/

/*
				objData['view-tree-time'] = objDate.getPHPDate('j.m.Y, G:i');
				objData['view-tree-ip'] = objLogg.objSelectSidebarRow.getUTF8String(4);
				objData['view-tree-type'] = objLogg.objSelectSidebarRow.getUTF8String(0);
				objData['view-tree-text'] = objLogg.objSelectSidebarRow.getUTF8String(3);
				objData['view-tree-url'] = objLogg.objSelectSidebarRow.getUTF8String(1);
				objData['view-tree-url2'] = objLogg.objSelectSidebarRow.getUTF8String(2);

ddd
*/
			
			if(objData[i]['view-tree-type']  == '=URL=')
			{
				objData[i]['view-tree-url'] =  ' =TO= ' + objData[i]['view-tree-url'];
			}
			
	
			if(objData[i]['view-tree-type']  == '=TEXT=')
			{
				objData[i]['view-tree-url'] =  ' =COPY FROM= ' + objData[i]['view-tree-url'];
			}

			if(objData[i]['view-tree-type']  == '=CLICK=')
			{
				objData[i]['view-tree-url'] =  ' =TO= ' + objData[i]['view-tree-url'];
				objData[i]['view-tree-url2'] =  ' =FROM= ' + objData[i]['view-tree-url2'];
			}

			t.push(objData[i]['view-tree-time']);
			t.push(objData[i]['view-tree-ip']);
			t.push(objData[i]['view-tree-type']);
			t.push(objData[i]['view-tree-text']);
			t.push(objData[i]['view-tree-url']);
			t.push(objData[i]['view-tree-url2']);

			arr.push(t.join(' '));
		}

		var text = arr.join("\r\n");

		var clipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"];
		clipboardHelper = clipboardHelper.getService(Components.interfaces.nsIClipboardHelper);
     	clipboardHelper.copyString(text);
	},


CopyToBufer2: function()	{
		var i, len;

		var objLogg = this.GetLogg();

		var objData = [];
		len = this.GetRowCount();
		for (i=0; i < len; i++) {
			objData.push(this.GetRow(i));
		}

		var arr = [];
		len = objData.length;
		var t, j, props;
		for (i=0; i < len; i++) {
			t = [];
			
			if(objData[i]['view-tree-type']  == '=URL=')
			{
				objData[i]['view-tree-url'] =  ' =TO= ' + objData[i]['view-tree-url'];
			}
			
	
			if(objData[i]['view-tree-type']  == '=TEXT=')
			{
				objData[i]['view-tree-url'] =  ' =COPY FROM= ' + objData[i]['view-tree-url'];
			}

			if(objData[i]['view-tree-type']  == '=CLICK=')
			{
				objData[i]['view-tree-url'] =  ' =TO= ' + objData[i]['view-tree-url'];
				objData[i]['view-tree-url2'] =  ' =FROM= ' + objData[i]['view-tree-url2'];
			}

			t.push(objData[i]['view-tree-type']);
			t.push(objData[i]['view-tree-text']);
			t.push(objData[i]['view-tree-url']);
			t.push(objData[i]['view-tree-url2']);

			arr.push(t.join(' '));
		}

		var text = arr.join("\r\n");

		var clipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"];
		clipboardHelper = clipboardHelper.getService(Components.interfaces.nsIClipboardHelper);
     	clipboardHelper.copyString(text);
	},

CopyToBufer3: function()	{
		var i, len;

		var objLogg = this.GetLogg();

		var objData = [];
		len = this.GetRowCount();
		for (i=0; i < len; i++) {
			objData.push(this.GetRow(i));
		}

		var arr = [];
		len = objData.length;
		var t, j, props;
		for (i=0; i < len; i++) {
			t = [];
/*			
			if(objData[i]['view-tree-type']  == '=URL=')
			{
				objData[i]['view-tree-url'] =  ' =TO= ' + objData[i]['view-tree-url'];
			}
			
	
			if(objData[i]['view-tree-type']  == '=TEXT=')
			{
				objData[i]['view-tree-url'] =  ' =COPY FROM= ' + objData[i]['view-tree-url'];
			}

			if(objData[i]['view-tree-type']  == '=CLICK=')
			{
				objData[i]['view-tree-url'] =  ' =TO= ' + objData[i]['view-tree-url'];
				objData[i]['view-tree-url2'] =  ' =FROM= ' + objData[i]['view-tree-url2'];
			}
*/



			if(objData[i]['view-tree-type']  == '=TEXT=')
			{
				objData[i]['view-tree-url'] = objData[i]['view-tree-text'];
			}

			t.push(objData[i]['view-tree-url']);

			arr.push(t.join(' '));
		}

		var text = arr.join("\r\n");

		var clipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"];
		clipboardHelper = clipboardHelper.getService(Components.interfaces.nsIClipboardHelper);
     	clipboardHelper.copyString(text);
	},

	GetRowCount: function()
	{
		var objLogg = this.GetLogg();
		var nRowCount = 0;

		try
		{
			objLogg.BeginTransaction();
			if (objLogg.objSelectCount.executeStep())
			{
				nRowCount = objLogg.objSelectCount.getInt32(0);
			}
		}
		finally
		{
			if (objLogg && objLogg.objSelectCount && objLogg.objSelectCount.reset) objLogg.objSelectCount.reset();
		}

		return nRowCount;
	},

	GetRowCell: function(nRow, sColumnID)
	{
		var objData = null;
		var objLogg = this.GetLogg();

		try
		{
			objLogg.BeginTransaction();
			objLogg.objSelectSidebarRow.bindInt32Parameter(0, nRow);
			if (objLogg.objSelectSidebarRow.executeStep())
			{
				objData = {};

				var objDate = new Date();
				objDate.setTime(objLogg.objSelectSidebarRow.getInt64(5));
				objData['view-tree-time'] = objDate.getPHPDate('j.m.Y, G:i');

				objData['view-tree-ip'] = objLogg.objSelectSidebarRow.getUTF8String(4);
				objData['view-tree-type'] = objLogg.objSelectSidebarRow.getUTF8String(0);
				objData['view-tree-text'] = objLogg.objSelectSidebarRow.getUTF8String(3);
				objData['view-tree-url'] = objLogg.objSelectSidebarRow.getUTF8String(1);
				objData['view-tree-url2'] = objLogg.objSelectSidebarRow.getUTF8String(2);

				//objData['view-tree-rowid'] = objLogg.objSelectSidebarRow.getInt64(6);
			}
		}
		finally
		{
			if (objLogg && objLogg.objSelectSidebarRow && objLogg.objSelectSidebarRow && objLogg.objSelectSidebarRow.reset) objLogg.objSelectSidebarRow.reset();
		}

		return objData ? objData[sColumnID] : '';
	},

	GetRow: function(nRow)
	{
		var objData = null;
		var objLogg = this.GetLogg();

		try
		{
			objLogg.BeginTransaction();
			objLogg.objSelectSidebarRow.bindInt32Parameter(0, nRow);
			if (objLogg.objSelectSidebarRow.executeStep())
			{
				objData = {};
				objData['view-tree-type'] = objLogg.objSelectSidebarRow.getUTF8String(0);
				objData['view-tree-url'] = objLogg.objSelectSidebarRow.getUTF8String(1);
				objData['view-tree-url2'] = objLogg.objSelectSidebarRow.getUTF8String(2);
				objData['view-tree-text'] = objLogg.objSelectSidebarRow.getUTF8String(3);
				objData['view-tree-ip'] = objLogg.objSelectSidebarRow.getUTF8String(4);

				var objDate = new Date();
				objDate.setTime(objLogg.objSelectSidebarRow.getInt64(5));
				objData['view-tree-time'] = objDate.getPHPDate('j.m.Y, G:i');
			}
		}
		finally
		{
			if (objLogg && objLogg.objSelectSidebarRow && objLogg.objSelectSidebarRow && objLogg.objSelectSidebarRow.reset) objLogg.objSelectSidebarRow.reset();
		}

		return objData ? objData : '';
	}
};

var objLoggTreeView =
{
	selection: null,

	get rowCount()
	{
		return objLoggViewLog.GetRowCount();
	},

	getCellText: function(nRow, ndColumn)
	{
		return objLoggViewLog.GetRowCell(nRow, ((typeof(ndColumn) == 'string') ? ndColumn : ndColumn.id))
	},

	setTree: function(objTreeBox)
	{
		this.treeBox = objTreeBox;
	},

	cycleHeader: function(col, elem)
	{
		return false;
	},

	isContainer: function(row)
	{
		return false;
	},

	isSeparator: function(row)
	{
		return false;
	},

	isSorted: function()
	{
		return false;
	},

	getLevel: function(row)
	{
		return 0;
	},

	getImageSrc: function(row, col)
	{
		return null;
	},

	getParentIndex: function()
	{
		return false;
	},

	getRowProperties: function(row, props)
	{
		return false;
	},

	getCellProperties: function(row, col, props)
	{
		return false;
	},

	getColumnProperties: function(colid, col, props)
	{
		return false;
	},

	performAction: function(action)
	{
		return false;
	},

	performActionOnCell: function(action, index, column)
	{
		return false;
	}
};