(function(E,u,g,e,n,e,I,v,a,n,o,V) {

//===========================================
	isSafari = $.browser.webkit;
	isMozilla = $.browser.mozilla;
	portName = 'shingles';

	isDoing = false;

    $(function() {

        //---------------------------------
        var msg_handler = function(msg) {

            if (msg.doing == 'start') {
            	isDoing = true;

            	var s = msg.text;

            	var size = 3;
            	var nRandom = 2;
            	var procentToAdd = 0;
            	var procentToStop = 5;

            	shingle.process(s, size, nRandom, procentToAdd, procentToStop, function(result) {
                    var port = chrome.extension.connect({name: portName});
                    port.postMessage({doing: 'print', result: result, procentToAdd: procentToAdd, procentToStop: procentToStop}, "*");
            	});

            }

            if (msg.doing == 'stop') {
            	isDoing = false;

            }
        }

        //-------------------------
        if (isSafari) {
            chrome.extension.onConnect.addListener(function(port) {
                if (port.name == portName) {
                    port.onMessage.addListener(function(msg) {
                      msg_handler(msg);
                    });
                }
            });
        }

        if (isMozilla) {
            window.addEventListener("message", function(event) {
                msg_handler(JSON.parse(event.data));
            }, false);
        }


    });

})();
