portName = 'shingles';

var Logg_is_work = 0;

$(document).bind("click", function(event) {
	if (!Logg_is_work) return true;

    var prefManager = Shingles.IO.init();

    var s = event.target;
    while (s && s.tagName != 'A' && s.tagName != 'BODY') {
    	s = s.parentNode;
    }

	if (s.tagName == 'A') {
		var urlFrom = getBrowser().contentWindow.location;
		if (!urlFrom) return true;
		var urlTo = s.href;
		if (!urlTo) return true;
		var savedIP = prefManager.getChar("extensions.Shingles.currentIP");

		var text = clearHtml(s.innerHTML);

		objLogg.linkClick_insert(urlFrom, urlTo, text, (new Date).getTime(), savedIP);
	}
});

$('#urlbar').bind("keydown", function(event) {
	if (!Logg_is_work) return true;

    var prefManager = Shingles.IO.init();

	if (event.which == 13) {
		var url = this.value;
		var savedIP = prefManager.getChar("extensions.Shingles.currentIP");

		if ($.trim(url)) {
			objLogg.urlBar_insert(url, (new Date).getTime(), savedIP);
		}
	}
});

function cmd_Logg_run() {
	Logg_is_work = (!Logg_is_work) ? 1 : 0;
	var button = $('#Logg-run')[0];
	if (!Logg_is_work) {
		button.label = 'Старт';
	} else {
		button.label = 'Стоп';
	}
}

function cmd_Logg_clear() {
	objLogg.clearLog();
}

function cmd_Logg_copytoclip() {
	var i, len;

	var objData = [];

	var nRowCount = 0;

	try
	{
    	objLogg.BeginTransaction();
    	if (objLogg.objSelectCount.executeStep())
    	{
    		nRowCount = objLogg.objSelectCount.getInt32(0);
    	}
	}
	finally
	{
		if (objLogg && objLogg.objSelectCount && objLogg.objSelectCount.reset) objLogg.objSelectCount.reset();
	}

	len = nRowCount;

	for (i=0; i < len; i++) {
		objData.push(objLogg.GetRow(i));
	}

	var arr = [];
	len = objData.length;
	var t, j, props;
	for (i=0; i < len; i++) {
		t = [];
		for (j in objData[i]) {
			t.push(objData[i][j]);
		}

		arr.push(t.join(' '));
	}

	var text = arr.join("\n");

	var clipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"];
	clipboardHelper = clipboardHelper.getService(Components.interfaces.nsIClipboardHelper);
 	clipboardHelper.copyString(text);
}

function cmd_Logg_clearcookies() {
    var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager);

    var domainsToCheck = ['wmzona.com'];

    var iter = cookieManager.enumerator;
    while (iter.hasMoreElements()) {
    	var cookie = iter.getNext();
    	if (cookie instanceof Components.interfaces.nsICookie) {

    		var doDelete = true;

    	    for (var i = 0 ; i < domainsToCheck.length ; i++) {
        		var currDomainCheck = domainsToCheck[i];

        		if ((cookie.host).indexOf(currDomainCheck) != -1) {
        			doDelete = false;
        		}

        		if (doDelete) {
        		    //alert('known cookie: [' + cookie.host + '] [' + cookie.name + '] [' + cookie.value + ']');
        		    cookieManager.remove(cookie.host, cookie.name, cookie.path, cookie.blocked);
        		}
    	    }
    	}
	}
}

function cmd_Logg_addsite(event) {
	//if (!Logg_is_work) return true;

    var prefManager = Shingles.IO.init();

	var url = getBrowser().contentWindow.location;
	if (!url) return true;
	var savedIP = prefManager.getChar("extensions.Shingles.currentIP");

	objLogg.menuSite_insert(url, (new Date).getTime(), savedIP);
}

function cmd_Logg_addtext(event) {
	//if (!Logg_is_work) return true;

    var prefManager = Shingles.IO.init();

	var focusedWindow = document.commandDispatcher.focusedWindow;
	var selection = focusedWindow.getSelection();;
	var text = String(selection);
	if (!text) return true;

	var url = getBrowser().contentWindow.location;
	if (!url) return true;
	var savedIP = prefManager.getChar("extensions.Shingles.currentIP");

	objLogg.menuSiteText_insert(url, text, (new Date).getTime(), savedIP);
}


function Shingles_open() {
	ffPrefWindow = window.openDialog("chrome://Shingles/content/addon/prefs.xul", "Shingles", "chrome, resizable=true, persist=true, sizemode=normal");
}

function cmd_Logg_show() {
	ffViewLogWindow = window.openDialog('chrome://Shingles/content/logg_view_log.xul', 'shinglesViewLog', 'centerscreen,chrome,modal');
}

// get the referer from a document
getReferer = function(d) {
	var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var loc;
	// do we have a location?
	if ("location" in d) {
		loc = d.location;
	} else {
		linkyShared.trace("No location in " + d);
	}
	var ret = ioService.newURI(loc, null, null);
	//linkyShared.trace("getReferer: " + ret.spec);
	return ret;
}


function cmd_Logg_help() {
	var url = 'http://wmzona.com/gptr/news.php?action=open&item=161926';

	var browser;
	try {
		browser = getBrowser();
	} catch (ex if ex instanceof ReferenceError) {
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var browserWin = windowMediator.getMostRecentWindow("navigator:browser");
		if (!browserWin) {
			window.openDialog(getBrowserURL(), "_blank", "chrome,all,dialog=no", url, null, getReferer(document.commandDispatcher.focusedWindow.document));
			return;
		} else {
			browser = browserWin.getBrowser();
		}
	}
	try {
		browser.addTab(url, getReferer(document.commandDispatcher.focusedWindow.document));
	} catch(err) {
	}

}


function cmd_Shingles_site() {
	var url = 'http://wmzona.com/';

	var browser;
	try {
		browser = getBrowser();
	} catch (ex if ex instanceof ReferenceError) {
		var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var browserWin = windowMediator.getMostRecentWindow("navigator:browser");
		if (!browserWin) {
			window.openDialog(getBrowserURL(), "_blank", "chrome,all,dialog=no", url, null, getReferer(document.commandDispatcher.focusedWindow.document));
			return;
		} else {
			browser = browserWin.getBrowser();
		}
	}
	try {
		browser.addTab(url, getReferer(document.commandDispatcher.focusedWindow.document));
	} catch(err) {
	}

}

window.cancelSignal = false;

function cmd_Shingles_run() {
	var doc = window._content.document;

	var cancelText = 'Отмена';
	var startText = 'Запуск';

	var isCancel = ($('#Shingles-run')[0].label == cancelText);
	if (isCancel) {
		window.cancelSignal = true;
		return false;
	}

	window.cancelSignal = false;

	var tList = $('textarea[id*=contenttext]', doc);

	//$('#image_info', doc).remove();
	//$('#stat', doc).remove();
    //$('<div id="image_info">Думаю...</div>', doc).insertAfter(t);

    var io = Shingles.IO.init();

    var size = io.getChar('options.size');
    if (!size) size = 6;
    var limitLoad = io.getChar('options.limitLoad');
    if (!limitLoad) limitLoad = 1;
    if (limitLoad > 5 || limitLoad < 1) limitLoad = 1;
    var sizeVerify = io.getChar('options.sizeVerify');
    if (!sizeVerify) sizeVerify = 4;
    var nRandom = io.getChar('options.nRandom');
    if (!nRandom) nRandom = 3;
    var timeout = io.getChar('options.timeout');
    if (!timeout) timeout = 5;
    var procentToAdd = io.getChar('options.procentToAdd');
	if (!procentToAdd) procentToAdd = 3;
    var procentToStop = io.getChar('options.procentToStop');
    if (!procentToStop) procentToStop = 99;
    var yandexReq = io.getChar('options.yandexReq');
    if (!yandexReq) yandexReq = 'http://yandex.ru/yandsearch?text="%s"';
    var googleReq = io.getChar('options.googleReq');
    if (!googleReq) googleReq = 'http://www.google.com/search?ie=UTF-8&num=10&hl=en&q="%s"';

    if (!tList.length) return false;

    var sh = 0;
	var valueAll = 0;
	var sl;
    tList.each(function(index, item) {
		sh = shingle.createShingles($(item).val(), size);
		sl = (Math.min(sh.length, nRandom))*2;
		valueAll += sl+(sl*limitLoad);
    });

    //$('#Shingles-run')[0].disabled = true;
    $('#Shingles-run')[0].label = cancelText;
    $('#Shingles-stat')[0].textContent = 'Выполняем 0%';
	var progressEl = $('#Shingles-progress');
    progressEl[0].value = 0;
    progressEl[0].valueAll = valueAll;
    progressEl[0].valueCount = 0;
    $('#Shingles-progress').show();

    var itemResult_id, itemResult, s;

    tList = $.makeArray(tList);

    var processNext = function() {
    	item = tList.shift();

		s = $(item).val();

		itemResult_id = item.id.replace(/contenttext/i, 'contentrez');
		itemResult = $('#'+itemResult_id, doc);
		if (!itemResult.length) return true;

		itemResult.html('Выполняем...');

        shingle.process(s, size, sizeVerify, limitLoad, nRandom, procentToAdd, procentToStop, yandexReq, googleReq, timeout, function(result) {

            var port = chrome.extension.connect({name: portName});
            port.postMessage({doing: 'print',
            				  result: result,
            				  procentToAdd: procentToAdd,
            				  procentToStop: procentToStop,
            				  itemResult_id: itemResult_id
            }, "*");

            if (tList.length && !window.cancelSignal) {
            	return processNext();
            } else {
                //$('#Shingles-run')[0].disabled = false;
    			$('#Shingles-run')[0].label = startText;
                $('#Shingles-stat')[0].textContent = (window.cancelSignal) ? 'Ждём' : 'Готово';
                $('#Shingles-progress')[0].value = 100;
    		    $('#Shingles-progress').hide();
            }
        });

    }
    processNext();
}


